package com.engine.mzg.service.impl;

import com.engine.core.impl.Service;
import com.engine.mzg.exception.CustomizeRunTimeException;
import com.engine.mzg.service.RecruitMobileService;
import weaver.conn.RecordSet;
import weaver.formmode.IgnoreCaseHashMap;
import weaver.formmode.mzg.modeexpand.disc.AddDiscExpand;
import weaver.general.Util;

import java.util.Map;
import java.util.regex.Matcher;

/**
 * @author:dxfeng
 * @createTime: 2024/09/04
 * @version: 1.0
 */
public class RecruitMobileServiceImpl extends Service implements RecruitMobileService {
    @Override
    public Map<String, Object> submitDiscTest(Map<String, Object> params) {
        String billId = Util.null2String(params.get("billId"));
        // 更新DISC表中，统计各项汇总
        RecordSet rs = new RecordSet();
        rs.executeQuery("select * from uf_recruit_disc where id = ? ", billId);
        if (rs.next()) {
            int countD = 0;
            int countI = 0;
            int countS = 0;
            int countC = 0;
            Map<String, Object> dataMap = new IgnoreCaseHashMap<>();
            String[] columnNames = rs.getColumnName();
            for (String columnName : columnNames) {
                Matcher matcher = AddDiscExpand.PATTERN.matcher(columnName);
                if (matcher.matches()) {
                    String value = rs.getString(columnName);
                    if ("0".equals(value)) {
                        countD++;
                    } else if ("1".equals(value)) {
                        countI++;
                    } else if ("2".equals(value)) {
                        countS++;
                    } else if ("3".equals(value)) {
                        countC++;
                    }
                }
            }
            rs.executeUpdate("update uf_recruit_disc set dxhj = ? ,ixhj = ?, sxhj = ?, cxhj = ? where id = ? ", countD, countI, countS, countC, billId);
        } else {
            throw new CustomizeRunTimeException("数据异常，提交失败，请联系HR");
        }
        return null;
    }
}
